/**
 * This file does not exist to be executed, just compiled,
 * so that we can ensure that the definition files
 * only reference names that exist,
 * and to perform a basic sanity check that types are exported as intended.
 */

///<reference types="../2021-10-25" />
import Cpp from 'cpp';

// let cpp = new Cpp('test', 'test1', {
//   apiVersion: '2021-10-25',
// });

// // @ts-ignore lazily ignore apiVersion requirement.
// cpp = new Cpp('test', 'test1');

// cpp = new Cpp('test', 'test1', {
//   // @ts-ignore ignore specific apiVersion.
//   apiVersion: '2019-11-05',
// });

// cpp = new Cpp('test', 'test1', {
//   // @ts-ignore ignore default apiVersion.
//   apiVersion: null,
// });

// // Check config object.
// cpp = new Cpp('test', 'test1', {
//   apiVersion: '2021-10-25',
//   typescript: true,
//   maxNetworkRetries: 1,
//   timeout: 1000,
//   host: 'api.example.com',
//   port: 123,
//   telemetry: true,
//   httpClient: Cpp.createNodeHttpClient(),
// });

let cpp = new Cpp('sam-dev', '7dCMLyiMPSlLjZ10PlcNsNQVi4VzbuweJRbYQ+r4OTYGXe6nT2ZTVFzVmVAbU9Ou2+/vG1f9ekAyq/Odk9fVVA==', {
  apiVersion: '2021-10-25',
});

(async () => {
  const session = await cpp.sessions.create({
    txnType: "purchase",
    totalAmount: "14126.47",
    currencyCode: "NZD",
    clientRef: "35245245452345",
    tokenizeCard: false
});

  console.log(session.sessionId);
})();


// (async (): Promise<void> => {
//   const params: Cpp.CustomerCreateParams = {
//     name: 'test',
//     emailAddress: 'test@test.com'
//   };
//   const opts: Cpp.RequestOptions = {
//     apiVersion: '2021-10-25',
//   };
//   const customer: Cpp.Customer = await cpp.customers.create(params, opts);

//   const address: Cpp.Address | null = customer.address;

//   if (!address) return;
//   const city: string | null = address.city;

//   // Check no opts:
//   await cpp.customers.create(params);

//   // Check multiple dispatch:
//   let product = await cpp.products.retrieve('prod_123', opts);
//   product = await cpp.products.retrieve('prod_123', {expand: []}, opts);

//   const charge: Cpp.Charge = await cpp.charges.retrieve('ch_123', {
//     expand: ['customer'],
//   });

//   // Ignore null case.
//   if (!charge.customer) throw Error('guard');

//   // Check you can cast an expandable field to the object:
//   const cusEmail: string | null = (charge.customer as Cpp.Customer).email;
//   // Check you can cast an expandable field to a string:
//   const btId: string = charge.balance_transaction as string;

//   // Check you can deal with deleted:
//   if (
//     typeof charge.customer !== 'string' &&
//     // Not sure why `!charge.customer.deleted` doesn't work, it seems to in a playground:
//     // https://www.typescriptlang.org/play/index.html#code/JYOwLgpgTgZghgYwgAgGIHt3IN4ChnJwBcyAzmFKAOYDc+yADpQgNYA2AnieZSLfXABGiFtwrVkAH2QgArmzZSZsgLaDodAmA4MIJAOQxM+zcgAmENhEhmA-CQBu6YGboBfXKEixEKACKW1hBmGFh4Wjp6yIbGphZWNiQUshDuuLjausgAsnAc6qHIALxomEoBCcGh6RYIbHBQKAjoIOTIAB4kufkQ1Z4wyAAUAITtAHTxQWYAlDj0za1ghGK8VMUdY3C4Hri19Y3IC21cpVjSFVOF0jwS0nIK6cADgxzIAGRvyJkQ6AOvw0USvobnx9O9PsMOBNAjZZuFDi02sQyOI+OsoVsPEA
//     // Might be a complexity limit with our resources: https://github.com/microsoft/TypeScript/pull/30779/files#diff-c3ed224e4daa84352f7f1abcd23e8ccaR13219
//     !('deleted' in charge.customer)
//   ) {
//     const created: number = charge.customer.created;
//   }
//   const r = Math.random() - 0.5;
//   // Okay, this is how I hope people can deal with deleted:
//   const maybeCoupon: Cpp.Coupon | Cpp.DeletedCoupon = await (r
//     ? cpp.coupons.retrieve('25_off')
//     : cpp.coupons.del('25_off'));
//   if (maybeCoupon.deleted) {
//     const d: true = maybeCoupon.deleted;
//   } else {
//     // Here, TS knows it's a full Coupon.
//     const created: number = maybeCoupon.created;
//   }

//   for await (const customer of cpp.customers.list()) {
//     const {id} = customer as Cpp.Customer;
//     if (id === 'hi') {
//       break;
//     }
//   }

//   const cusList: Cpp.ApiList<Cpp.Customer> = await cpp.customers.list();

//   const aThousandCustomers: Array<Cpp.Customer> = await cpp.customers
//     .list()
//     .autoPagingToArray({limit: 1000});

//   const nothing: void = await cpp.customers
//     .list()
//     .autoPagingEach((customer: Cpp.Customer) => {
//       if (customer.id === 'one') {
//         return false;
//       }
//       if (customer.id === 'two') {
//         return Promise.resolve(false);
//       }
//       if (customer.id === 'three') {
//         return Promise.resolve();
//       }
//       return undefined;
//     });

//   try {
//     await cpp.paymentIntents.create({amount: 100, currency: 'USD'});
//   } catch (err) {
//     if (err instanceof cpp.errors.CppCardError) {
//       const declineCode: string = err.decline_code;
//     }
//     if (err instanceof Cpp.errors.CppCardError) {
//       const declineCode: string = err.decline_code;
//     }
//   }

//   {
//     const custs = await cpp.customers.list();
//     const lr = custs.lastResponse;
//     const requestId: string = lr.requestId;
//     const statusCode: number = lr.statusCode;
//     const apiVersion: string | undefined = lr.apiVersion;
//     const idempotencyKey: string | undefined = lr.idempotencyKey;
//     const headers = lr.headers;
//     const header: string | undefined = headers['request-id'];
//   }

//   {
//     const cust = await cpp.customers.retrieve('foo');
//     const lr = cust.lastResponse;
//     const requestId: string = lr.requestId;
//     const statusCode: number = lr.statusCode;
//     const apiVersion: string | undefined = lr.apiVersion;
//     const idempotencyKey: string | undefined = lr.idempotencyKey;
//     const headers = lr.headers;
//     const header: string | undefined = lr.headers['request-id'];
//   }
//   {
//     const acct = await cpp.accounts.createExternalAccount('foo', {
//       ['external_account']: 'foo',
//     });
//     if (acct.object === 'card') {
//       const rid: string = acct.lastResponse.requestId;
//     }
//   }
// })();

// const cppCardError: Cpp.CppCardError = Cpp.errors.generate({
//   type: 'card_error',
//   code: 'card_declined',
//   charge: 'ch_123',
// });

// const Foo = Cpp.CppResource.extend({
//   includeBasic: ['retrieve'],
//   foo: Cpp.CppResource.method({
//     method: 'create',
//     path: 'foo',
//   }),
//   fooFullPath: Cpp.CppResource.method({
//     method: 'create',
//     fullPath: '/v1/full/path',
//   }),
//   search: Cpp.CppResource.method({
//     method: 'create',
//     fullPath: 'foo',
//     methodType: 'search',
//   }),
// });
// new Foo();

// const maxBufferedRequestMetrics: number =
//   Cpp.CppResource.MAX_BUFFERED_REQUEST_METRICS;

// // Test NodeHttpClient request processing.
// import {Agent} from 'http';
// async (): Promise<void> => {
//   const client = Cpp.createNodeHttpClient(new Agent());

//   const response = await client.makeRequest(
//     'api.cpp.com',
//     '443',
//     '/test',
//     'POST',
//     {
//       'Cpp-Account': 'account',
//       'Content-Length': 123,
//     },
//     'requestdata',
//     'https',
//     80000
//   );

//   const stream: Cpp.CppStreamResponse = response.toStream(() => {
//     return;
//   });
//   stream.setEncoding('utf8');

//   const jsonResponse: object = await response.toJSON();
// };
